<?php

use Joomla\CMS\Factory;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Uri\Uri;

// Check if we're in Joombla
$isInsideJoomla = class_exists('Joomla\CMS\Factory');
echo "<script>\n\tvar isInsideJoomla = " . json_encode($isInsideJoomla) . ";\n</script>\n";

if ($isInsideJoomla) {

    defined('_JEXEC') or die;
    // dont allow anyone in that isn't logged in, we need to create a list of whitelisted URLs, so far its only the versions JSON page
    $user = Factory::getUser();
    if ($user->guest == 1) {
        $return = base64_encode(Uri::getInstance());
        $login_url_with_return = Route::_('index.php?option=com_users&view=login&return=' . $return);
        Factory::getApplication()->redirect($login_url_with_return);
    }

    echo "<script src='components/com_xytimeshifter/tiqGraphQLHelpers.js'></script>\n";
} else {
    echo "<script src='getToken.js'></script>\n";
    echo "<script src='tiqGraphQLHelpers.js'></script>\n";
    echo "<script src='https://code.jquery.com/jquery-3.3.1.js' integrity='sha256-2Kok7MbOyxpgUVvAk/HJ2jigOSYS2auK4Pfzbm7uH60=' crossorigin='anonymous'></script>\n";
    echo "<link href='https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css' rel='stylesheet'>\n";
    echo "<link rel='stylesheet' href='https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css' integrity='sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm' crossorigin='anonymous'>\n";
}

?>

<!-- <script src="media/com_thinkiq/js/dist/tiq.bundle.js"></script> -->

<script src="media/com_thinkiq/js/dist/tiq.core.js"></script>
<script src="media/com_thinkiq/js/dist/tiq.components.js"></script>
<script src="media/com_thinkiq/js/dist/tiq.charts.js"></script>

<!-- <script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script> -->
<!-- <script src="https://cdn.plot.ly/plotly-latest.min.js"></script> -->

<script>
    var Vue = core.Vue;
    var Plotly = charts.plotly;

Vue.component("thinkiq-plotly-tschart-2x2y", {
    props: ['id', 'title', 'heigth', 'width', 'chartdata'],
    data() {
        return {
            demoData: {
                lastUpdate: "",
                traces: [{
                        name: "Grower 1",
                        timestamps: ['2013-10-04 22:23:00', '2013-11-04 22:23:00', '2013-12-04 22:23:00'],
                        values: [3.3, 3.8, 4.1],
                        mode: 'markers'
                    },
                    {
                        name: "Grower 2",
                        timestamps: ['2013-10-05 22:23:00', '2013-11-05 22:23:00', '2013-12-05 22:23:00'],
                        values: [4.3, 2.8, 1.1],
                        mode: 'lines'
                    }
                ],
                highlights: [{
                    startdate: '2013-10-05 22:23:00',
                    enddate: '2013-10-05 22:23:00',
                    fillcolor: '#d3d3d3',
                    opacity: 0.2
                }],
                verticals: [{
                    date: '2013-10-05 22:23:00',
                }]
            }
        }
    },
    watch: {
        'chartdata.lastUpdate': function(newVal, oldVal) {
            this.show_chart();
        }
    },
    methods: {
        show_chart: function() {

            let config = {
                responsive: true,
                displayModeBar: false
            };

            let layout = {
                grid: {
                    rows: 2,
                    columns: 1,
                    pattern: 'coupled',
                    ygap: 0.1,
                    subplots: ['xy', 'x2y2']
                },
                title: this.title,
                margin: {
                    t: 100,
                    // l: 200
                },
                height: this.height,
                width: this.width,
                xaxis: {
                    range: this.chartdata.xAxisRange1,
                    side: 'top'
                },
                xaxis2: {
                    range: this.chartdata.xAxisRange2,
                    anchor: 'y2',
                    // overlaying: 'x2',
                    // side: 'bottom'
                },
                // yaxis: {title: 'attr 1'},
                // yaxis2: {
                //     title: 'attr2',
                //     titlefont: {color: 'rgb(148, 103, 189)'},
                //     tickfont: {color: 'rgb(148, 103, 189)'},
                //     overlaying: 'y',
                //     side: 'right'
                // },
                shapes: [],
                autosize: false,
                showlegend: false
            };

            let chart_data = [];
            for (let index = 0; index < this.chartdata.traces.length; index++) {
                const groupElement = this.chartdata.traces[index];

                chart_data.push({
                    x: groupElement.timestamps,
                    y: groupElement.values,
                    name: groupElement.name,
                    type: 'scatter',
                    mode: groupElement.mode,
                    marker: groupElement.marker,
                    yaxis: groupElement.yaxis,
                    xaxis: groupElement.xaxis
                });
            }

            layout.shapes = [];

            if (this.chartdata.highlights.length > 0) {
                for (let index = 0; index < this.chartdata.highlights.length; index++) {
                    const highlight = this.chartdata.highlights[index];
                    layout.shapes.push({
                        type: 'rect',
                        xref: 'x2',
                        yref: 'paper',
                        x0: highlight.startdate,
                        y0: highlight.y0,
                        x1: highlight.enddate,
                        y1: highlight.y1,
                        fillcolor: highlight.fillcolor,
                        opacity: highlight.opacity,
                        line: {
                            width: 0
                        }
                    });
                }
            }

            if (this.chartdata.verticals.length > 0) {
                for (let index = 0; index < this.chartdata.verticals.length; index++) {
                    const vertical = this.chartdata.verticals[index];
                    layout.shapes.push({
                        type: 'line',
                        xref: 'x',
                        yref: 'paper',
                        x0: vertical.date,
                        y0: 0,
                        x1: vertical.date,
                        y1: 0.5,
                        line: {
                            color: 'rgb(128, 0, 128)',
                            width: 2,
                            dash: 'dot'
                        }
                    });
                }
            }

            Plotly.newPlot(
                this.id,
                chart_data,
                layout,
                config
            );

            var myPlot = document.getElementById(this.id);
            myPlot.on('plotly_click', function(data) {
                console.log('plotly_click');
            });

        },

    },
    template: `
        <div :id=id></div>
    `,
    mounted() {
        this.show_chart();
    }
});

Vue.component("thinkiq-plotly-tschart", {
    props: ['id', 'title', 'heigth', 'width', 'chartdata'],
    data() {
        return {
            demoData: {
                lastUpdate: "",
                traces: [{
                        name: "Grower 1",
                        timestamps: ['2013-10-04 22:23:00', '2013-11-04 22:23:00', '2013-12-04 22:23:00'],
                        values: [3.3, 3.8, 4.1],
                        mode: 'markers'
                    },
                    {
                        name: "Grower 2",
                        timestamps: ['2013-10-05 22:23:00', '2013-11-05 22:23:00', '2013-12-05 22:23:00'],
                        values: [4.3, 2.8, 1.1],
                        mode: 'lines'
                    }
                ],
                highlights: [{
                    startdate: '2013-10-05 22:23:00',
                    enddate: '2013-10-05 22:23:00',
                    fillcolor: '#d3d3d3',
                    opacity: 0.2
                }],
                verticals: [{
                    date: '2013-10-05 22:23:00',
                }]
            }
        }
    },
    watch: {
        'chartdata.lastUpdate': function(newVal, oldVal) {
            this.show_chart();
        }
    },
    methods: {
        show_chart: function() {

            let config = {
                responsive: true,
                displayModeBar: false
            };

            let layout = {
                title: this.title,
                margin: {
                    t: 100,
                    // l: 200
                },
                height: this.height,
                width: this.width,
                xaxis: {
                    range: this.chartdata.xAxisRange,
                    title: 'blue'
                },
                yaxis: {
                    title: 'orange'
                },
                shapes: [],
                autosize: false,
                showlegend: false
            };

            let chart_data = [];
            for (let index = 0; index < this.chartdata.traces.length; index++) {
                const groupElement = this.chartdata.traces[index];

                chart_data.push({
                    x: groupElement.timestamps,
                    y: groupElement.values,
                    name: groupElement.name,
                    type: 'scatter',
                    mode: groupElement.mode,
                    marker: groupElement.marker,
                    yaxis: groupElement.yaxis
                });

                let fit=Math.linest(groupElement.timestamps, groupElement.values);

                chart_data.push({
                    x: fit[0],
                    y: fit[1],
                    type: 'lines',
                });

                layout.title+=` R<sup>2</sup>=${Math.round(fit[2] * 100) / 100}`;
            }

            layout.shapes = [];

            if (this.chartdata.highlights.length > 0) {
                for (let index = 0; index < this.chartdata.highlights.length; index++) {
                    const highlight = this.chartdata.highlights[index];
                    layout.shapes.push({
                        type: 'rect',
                        xref: 'x2',
                        yref: 'paper',
                        x0: highlight.startdate,
                        y0: highlight.y0,
                        x1: highlight.enddate,
                        y1: highlight.y1,
                        fillcolor: highlight.fillcolor,
                        opacity: highlight.opacity,
                        line: {
                            width: 0
                        }
                    });
                }
            }

            if (this.chartdata.verticals.length > 0) {
                for (let index = 0; index < this.chartdata.verticals.length; index++) {
                    const vertical = this.chartdata.verticals[index];
                    layout.shapes.push({
                        type: 'line',
                        xref: 'x',
                        yref: 'paper',
                        x0: vertical.date,
                        y0: 0,
                        x1: vertical.date,
                        y1: 0.5,
                        line: {
                            color: 'rgb(128, 0, 128)',
                            width: 2,
                            dash: 'dot'
                        }
                    });
                }
            }

            Plotly.newPlot(
                this.id,
                chart_data,
                layout,
                config
            );

            var myPlot = document.getElementById(this.id);
            myPlot.on('plotly_click', function(data) {
                console.log('plotly_click');
            });

        },

    },
    template: `
        <div :id=id></div>
    `,
    mounted() {
        this.show_chart();
    }
});

Math.linest = function(values_x, values_y) {
    
    /*
     * https://dracoblue.net/dev/linear-least-squares-in-javascript/
     */

    var sum_x = 0;
    var sum_y = 0;
    var sum_xy = 0;
    var sum_xx = 0;
    var sum_yy = 0;
    var count = 0;

    /*
     * We'll use those variables for faster read/write access.
     */
    var x = 0;
    var y = 0;
    var values_length = values_x.length;

    if (values_length != values_y.length) {
        throw new Error('The parameters values_x and values_y need to have same size!');
    }

    /*
     * Nothing to do.
     */
    if (values_length === 0) {
        return [
            [],
            []
        ];
    }

    /*
     * Calculate the sum for each of the parts necessary.
     */
    for (var v = 0; v < values_length; v++) {
        x = values_x[v];
        y = values_y[v];
        sum_x += x;
        sum_y += y;
        sum_xx += x * x;
        sum_xy += x * y;
        sum_yy += y * y;
        count++;
    }

    /*
     * Calculate m and b for the formular:
     * y = x * m + b
     */
    var m = (count * sum_xy - sum_x * sum_y) / (count * sum_xx - sum_x * sum_x);
    var b = (sum_y / count) - (m * sum_x) / count;

    /*
     * We will make the x and y result line now
     */
    var result_values_x = [];
    var result_values_y = [];

    for (var v = 0; v < values_length; v++) {
        x = values_x[v];
        y = x * m + b;
        result_values_x.push(x);
        result_values_y.push(y);
    }
    
    var r2 = Math.pow((count*sum_xy - sum_x*sum_y)/Math.sqrt((count*sum_xx-sum_x*sum_x)*(count*sum_yy-sum_y*sum_y)),2);
    
    return [result_values_x, result_values_y, r2];
}
</script>

<h1 class="pb-4 text-center">TimeShift /w Focus</h1>

<div id="app" class="d-flex flex-column align-items-center">
    <!-- Load duration picker component -->
    <div class="pb-4 row d-flex flex-row form-inline">

        <input class="form-control mr-4 mb-3" type="text" v-model="meta.tags[0]" placeholder="attrId1"
            @change="() => tagChange(0)" />
        <input class="form-control mr-4 mb-3" type="text" v-model="meta.tags[1]" placeholder="attrId2"
            @change="() => tagChange(1)" />
        <input class="form-control mr-4 mb-3" type="text" v-model="baseOffsetSec" placeholder="base offset in seconds"
            @change="onPlayOrStopClick" />

        <duration-picker ref="datePicker" :show-pan-controls="true" :show-duration-controls="true"
            :start-date="startDate.toISOString()" :end-date="endDate.toISOString()"
            @on_date_change="onDateChange">
        </duration-picker>

        <button class="btn btn-sm btn-primary" @click="onPlayOrStopClick">Load</button>

    </div>

    <div>
        <p v-if="tag1.displayName">
            Attribute 1: {{tag1.displayName}} on Equipment: {{tag1.onEquipment.displayName}}
        </p>
        <p v-if="tag2.displayName">
            Attribute 2: {{tag2.displayName}} on Equipment: {{tag2.onEquipment.displayName}}
        </p>
    </div>

    <div class="row w-100">
        <div class="col-5">
            <thinkiq-plotly-tschart-2x2y id="tsChart_1" title="Raw Tags" height="400" width="800"
                :chartdata="tsChartData">
            </thinkiq-plotly-tschart-2x2y>
        </div>

        <div class="col-2">
            <h4 class="pt-4">Time Span and Shift</h4>
            <div class="pt-4">
                <button @click="() => {shiftTrace(-100);}"> <i class="fa fa-angle-left"></i> </button>
                <span style="width:50px;display:inline-block;text-align:center">{{shiftSeconds}} s</span>
                <button @click="() => {shiftTrace(100);}"> <i class="fa fa-angle-right"></i> </button>
            </div>
            <div class="pt-4">
                {{totalTimeSpanSec}} Seconds<br />
                {{Math.round(totalTimeSpanSec / 60 * 100) / 100}} Minutes
            </div>

            <h4 class="pt-4">Time Steps</h4>
            <div class="pt-4">
                <button @click="() => {changeTimeStep(-5);}"> <i class="fa fa-angle-left"></i> </button>
                <span style="width:45px;display:inline-block;text-align:center">{{timeStepSeconds}} s</span>
                <button @click="() => {changeTimeStep(5);}"> <i class="fa fa-angle-right"></i> </button>
            </div>
            <div class="pt-4">
                {{Math.round(totalTimeSpanSec / timeStepSeconds)}} Timestamps<br />
            </div>

        </div>

        <div class="col-5">
            <thinkiq-plotly-tschart id="scatterChart_1" title="XY Scatter" height="400" width="500"
                :chartdata="scatterChartData">
            </thinkiq-plotly-tschart>
        </div>

    </div>
</div>


</div>


<script>
// a simple vue app
//create instance of the vuejs
var app = new Vue({
    el: "#app",
    // components: {
    //     "duration-picker": tiq.DurationPicker
    // },
    data() {
        return {
            startDate: new Date(),
            endDate: new Date(),

            baseOffsetSec: 500,

            startDateOffset: new Date(),
            endDateOffset: new Date(),

            scatterStartDate: new Date(),
            scatterEndDate: new Date(),
            scatterTimeSteps: [],
            totalTimeSpanSec: 0,
            shiftSeconds: 0,
            timeStepSeconds: 10,
            tag1: {},
            tag2: {},
            meta: {
                "start": 1617958430000,
                "end": 1617971625000,
                "aggregate": "raw",
                "tags": ["156249", "156251"]
            },
            tsChartData: {
                lastUpdate: null,
                traces: [],
                highlights: [],
                verticals: [],
                xAxisRange: [],
                resetData: () => {
                    this.traces = [];
                    this.highlights = [];
                    this.verticals = [];
                    this.xAxisRange = [];
                }
            },
            scatterChartData: {
                lastUpdate: null,
                traces: [],
                highlights: [],
                verticals: [],
                xAxisRange: [],
                resetData: () => {
                    this.traces = [];
                    this.highlights = [];
                    this.verticals = [];
                    this.xAxisRange = [];
                }
            }

        }
    },
    methods: {
        onstart: function() {
            this_vue = this;

            this_vue.shiftSeconds = 0;
            this_vue.startDate = new Date(this_vue.meta.start);
            this_vue.endDate = new Date(this_vue.meta.end);

            // get attributes
            let query = `
                    query MyQuery {
                        attributes(filter: {id: {in: ${JSON.stringify(this_vue.meta.tags)}}}){
                            id displayName onEquipment{ id displayName}
                        }
                    }
                    `;

            makeRequestAsync(query).then((data) => {
                this_vue.tag1 = data.data.attributes[0];
                this_vue.tag2 = data.data.attributes[1];
                this_vue.onPlayOrStopClick();
            });

        },
        tagChange: function(i) {
            this_vue = this;

            // get attributes
            let query = `
                    query MyQuery {
                        attributes(filter: {id: {in: ${JSON.stringify(this_vue.meta.tags[i])}}}){
                            id displayName onEquipment{ id displayName}
                        }
                    }
                    `;

            makeRequestAsync(query).then((data) => {
                this_vue[`tag${i + 1}`] = data.data.attributes[0];
                this_vue.onPlayOrStopClick();
            });
        },
        //duration picker event handler
        onDateChange: function(start_date, end_date) {
            this_vue.startDate = new Date(start_date);
            this_vue.endDate = new Date(end_date);

            this.onPlayOrStopClick();
        },

        shiftTrace: function(shiftSeconds) {
            this_vue = this;

            this.shiftSeconds += shiftSeconds;
            this.tag2.trace.timestamps.forEach((x, i) => {
                this.tag2.trace.timestamps[i] = new Date(x.getTime() + shiftSeconds * 1000);
            });
            this_vue.retrace();
        },

        changeTimeStep: function(shiftSeconds) {
            if (this.timeStepSeconds + shiftSeconds > 0) {
                this.timeStepSeconds += shiftSeconds;
                this.rescatter();
            }
        },

        onPlayOrStopClick: function() {
            this_vue = this;

            this_vue.tsChartData.resetData();
            this_vue.scatterChartData.resetData();
            this_vue.shiftSeconds = 0;

            // this_vue.startDate = new Date(this_vue.$refs.datePicker.startDate);
            // this_vue.endDate = new Date(this_vue.$refs.datePicker.endDate);
            this_vue.startDateOffset = new Date(this_vue.startDate.getTime() + this_vue.baseOffsetSec *
                1000);
            this_vue.endDateOffset = new Date(this_vue.endDate.getTime() + this_vue.baseOffsetSec * 1000);

            Promise.all([

                getRawHistoryDataWithSamplingAsync([this_vue.tag1.id], this_vue.startDate, this_vue
                    .endDate),
                getRawHistoryDataWithSamplingAsync([this_vue.tag2.id], this_vue.startDateOffset,
                    this_vue.endDateOffset)

            ]).then(function(responses) {

                let traces1 = data2traces(responses[0], true);
                this_vue.tag1.trace = traces1[this_vue.tag1.id];

                let traces2 = data2traces(responses[1], true);
                this_vue.tag2.trace = traces2[this_vue.tag2.id];

                this_vue.retrace();

            });

            // getRawHistoryDataWithSamplingAsync([this_vue.tag1.id, this_vue.tag2.id], this_vue.startDate, this_vue.endDate).then((data) => {
            //     let traces = data2traces(data, true);
            //     this_vue.tag1.trace = traces[this_vue.tag1.id];
            //     this_vue.tag2.trace = traces[this_vue.tag2.id];
            //     this_vue.retrace();
            // });

        },

        retrace: function() {
            this_vue = this;

            this_vue.tsChartData.traces = [];
            for (let traceIndex = 0; traceIndex < this_vue.meta.tags.length; traceIndex++) {
                // for (const [key, traceTsData] of Object.entries(traces)) {
                const traceTsData = traceIndex == 0 ? this_vue.tag1.trace : this_vue.tag2.trace;
                this_vue.tsChartData.traces.push({
                    name: traceIndex == 0 ? this_vue.tag1.displayName : this_vue.tag2.displayName,
                    timestamps: traceTsData.timestamps,
                    values: traceTsData.values,
                    mode: "lines",
                    marker: {},
                    yaxis: traceIndex == 0 ? "y" : "y2",
                    xaxis: traceIndex == 0 ? "x" : "x2"
                });
            }

            this_vue.tsChartData.xAxisRange1 = [
                this_vue.startDate, this_vue.endDate
            ];
            this_vue.tsChartData.xAxisRange2 = [
                this_vue.startDateOffset, this_vue.endDateOffset
            ];

            this_vue.tsChartData.lastUpdate = new Date();

            this.rescatter();
        },
        interpol: function(t, ti, tii, vi, vii) {
            return (t - ti) * (vii - vi) / (tii - ti) + vi;
        },
        rescatter: function() {
            this_vue = this;

            this_vue.scatterChartData.traces = [];

            this_vue.scatterStartDate = this_vue.shiftSeconds > 0 ? new Date(this_vue.startDateOffset
                .getTime() + this_vue.shiftSeconds * 1000) : this_vue.startDateOffset;
            this_vue.scatterEndDate = this_vue.shiftSeconds < 0 ? new Date(this_vue.endDateOffset
                .getTime() + this_vue.shiftSeconds * 1000) : this_vue.endDateOffset;

            this_vue.tsChartData.highlights = [];
            this_vue.tsChartData.highlights.push({
                startdate: this_vue.scatterStartDate,
                enddate: this_vue.scatterEndDate,
                y0: 0,
                y1: 1,
                fillcolor: '#99ff33',
                opacity: 0.1
            });
            this_vue.tsChartData.lastUpdate = new Date();

            this_vue.totalTimeSpanSec = (this_vue.scatterEndDate.getTime() - this_vue.scatterStartDate
                .getTime()) / 1000;

            this_vue.tsChartData.verticals = [];

            // nearest int from a divisible by b
            //https://stackoverflow.com/a/29453731
            // (a + b) - (a % b)
            this_vue.scatterTimeSteps = [];
            this_vue.scatterX = [];
            this_vue.scatterY = [];
            tag1index = 0;
            tag2index = 0;
            let ts1 = new Date(this_vue.scatterStartDate.getTime() + this_vue.timeStepSeconds * 1000 - (
                this_vue.scatterStartDate.getTime() % this_vue.timeStepSeconds * 1000));
            while (ts1 < this_vue.scatterEndDate) {
                this_vue.scatterTimeSteps.push(ts1);
                let ts2 = new Date(ts1.getTime() + this_vue.baseOffsetSec * 1000);

                // interpolate tag1 value
                while (this_vue.tag1.trace.timestamps[tag1index] < ts1 && tag1index < this_vue.tag1.trace
                    .timestamps.length) {
                    tag1index++;
                }
                while (this_vue.tag2.trace.timestamps[tag2index] < ts2 && tag2index < this_vue.tag2.trace
                    .timestamps.length) {
                    tag2index++;
                }

                if (tag1index < this_vue.tag1.trace.timestamps.length && tag2index < this_vue.tag2.trace
                    .timestamps.length) {
                    let vx = null;
                    let vy = null;

                    if (this_vue.tag1.trace.timestamps[tag1index].getTime() == ts1.getTime()) {
                        vx = this_vue.tag1.trace.values[tag1index];
                    } else {
                        vx = this_vue.interpol(
                            ts1,
                            this_vue.tag1.trace.timestamps[tag1index - 1],
                            this_vue.tag1.trace.timestamps[tag1index],
                            this_vue.tag1.trace.values[tag1index - 1],
                            this_vue.tag1.trace.values[tag1index]
                        );
                    }

                    // interpolate tag2 value
                    if (this_vue.tag2.trace.timestamps[tag2index].getTime() == ts2.getTime()) {
                        vy = this_vue.tag2.trace.values[tag2index];
                    } else {
                        vy = this_vue.interpol(
                            ts2,
                            this_vue.tag2.trace.timestamps[tag2index - 1],
                            this_vue.tag2.trace.timestamps[tag2index],
                            this_vue.tag2.trace.values[tag2index - 1],
                            this_vue.tag2.trace.values[tag2index]
                        );
                    }

                    if (vx != null && vy != null) {
                        this_vue.scatterX.push(vx);
                        this_vue.scatterY.push(vy);
                    }
                }
                ts1 = new Date(ts1.getTime() + this_vue.timeStepSeconds * 1000);
            }

            this_vue.scatterChartData.traces.push({
                name: "stuff",
                timestamps: this_vue.scatterX,
                values: this_vue.scatterY,
                mode: "markers",
                marker: {
                    color: 'darkblue',
                    size: 6,
                    symbol: 'diamond-open'
                }
            });

            this_vue.scatterChartData.lastUpdate = new Date();

        }

    },
});

// use this for js offline
app.onstart();
</script>